diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/buildings/test/buildings-penetration-loss-pathloss-test.cc ns-3.39/src/buildings/test/buildings-penetration-loss-pathloss-test.cc
--- ns-3.38/src/buildings/test/buildings-penetration-loss-pathloss-test.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.39/src/buildings/test/buildings-penetration-loss-pathloss-test.cc	2023-07-05 14:23:47.717427000 -0700
@@ -0,0 +1,280 @@
+/*
+ * Copyright (c) 2023 Centre Tecnologic de Telecomunicacions de Catalunya (CTTC)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+#include "ns3/abort.h"
+#include "ns3/boolean.h"
+#include "ns3/building.h"
+#include "ns3/buildings-channel-condition-model.h"
+#include "ns3/channel-condition-model.h"
+#include "ns3/config.h"
+#include "ns3/constant-position-mobility-model.h"
+#include "ns3/constant-velocity-mobility-model.h"
+#include "ns3/double.h"
+#include "ns3/log.h"
+#include "ns3/mobility-building-info.h"
+#include "ns3/mobility-helper.h"
+#include "ns3/simulator.h"
+#include "ns3/test.h"
+#include "ns3/three-gpp-propagation-loss-model.h"
+
+using namespace ns3;
+
+NS_LOG_COMPONENT_DEFINE("BuildingsPenetrationLossesTest");
+
+/**
+ * \ingroup propagation-tests
+ *
+ * Test case for the 3GPP channel O2I building penetration losses.
+ * It considers pre-determined scenarios and based on the outdoor/indoor
+ * condition (O2O/O2I) checks whether the calculated received power
+ * is aligned with the calculation in 3GPP TR 38.901.
+ *
+ * For O2O condition the calculation is done according to Table 7.4.1-1
+ * and we check if the calculated received power is equal to the expected
+ * value.
+ * For the O2I condition, the calculation is done considering the building
+ * penetration losses based on the material of the building walls.
+ * In this case, we check if the calculated received power is less than the
+ * received value (thus ensure that losses have been included).
+ */
+
+class BuildingsPenetrationLossesTestCase : public TestCase
+{
+  public:
+    /**
+     * Constructor
+     */
+    BuildingsPenetrationLossesTestCase();
+
+    /**
+     * Destructor
+     */
+    ~BuildingsPenetrationLossesTestCase() override;
+
+  private:
+    /**
+     * Builds the simulation scenario and perform the tests
+     */
+    void DoRun() override;
+
+    /**
+     * Struct containing the parameters for each test
+     */
+    struct TestVector
+    {
+        Vector m_positionA; //!< the position of the first node
+        Vector m_positionB; //!< the position of the second node
+        double m_frequency; //!< carrier frequency in Hz
+        bool m_isLos;       //!< LOS probability
+        TypeId m_condModel; //!< the type ID of the channel condition model to be used
+        TypeId m_propModel; //!< the type ID of the propagation loss model to be used
+        double m_pt;        //!< transmitted power in dBm
+        double m_pr;        //!< received power in dBm
+    };
+
+    TestVectors<TestVector> m_testVectors;         //!< array containing all the test vectors
+    Ptr<ThreeGppPropagationLossModel> m_propModel; //!< the propagation loss model
+    double m_tolerance;                            //!< tolerance
+};
+
+BuildingsPenetrationLossesTestCase::BuildingsPenetrationLossesTestCase()
+    : TestCase("Test case for BuildingsPenetrationLosses"),
+      m_testVectors(),
+      m_tolerance(2e-3)
+{
+}
+
+BuildingsPenetrationLossesTestCase::~BuildingsPenetrationLossesTestCase()
+{
+}
+
+void
+BuildingsPenetrationLossesTestCase::DoRun()
+{
+    // create the test vector
+    TestVector testVector;
+
+    // tests for the RMa scenario
+    testVector.m_positionA = Vector(0, 0, 35.0); // O2I case
+    testVector.m_positionB = Vector(10, 0, 1.5);
+    testVector.m_frequency = 5.0e9;
+    testVector.m_propModel = ThreeGppRmaPropagationLossModel::GetTypeId();
+    testVector.m_pt = 0.0;
+    testVector.m_pr = -77.3784;
+    m_testVectors.Add(testVector);
+
+    testVector.m_positionA = Vector(0, 0, 35.0); // O2I case
+    testVector.m_positionB = Vector(100, 0, 1.5);
+    testVector.m_frequency = 5.0e9;
+    testVector.m_propModel = ThreeGppRmaPropagationLossModel::GetTypeId();
+    testVector.m_pt = 0.0;
+    testVector.m_pr = -87.2965;
+    m_testVectors.Add(testVector);
+
+    testVector.m_positionA = Vector(0, 0, 35.0); // O2O case
+    testVector.m_positionB = Vector(1000, 0, 1.5);
+    testVector.m_frequency = 5.0e9;
+    testVector.m_propModel = ThreeGppRmaPropagationLossModel::GetTypeId();
+    testVector.m_pt = 0.0;
+    testVector.m_pr = -108.5577;
+    m_testVectors.Add(testVector);
+
+    // tests for the UMa scenario
+    testVector.m_positionA = Vector(0, 0, 25.0); // O2I case
+    testVector.m_positionB = Vector(10, 0, 1.5);
+    testVector.m_frequency = 5.0e9;
+    testVector.m_propModel = ThreeGppUmaPropagationLossModel::GetTypeId();
+    testVector.m_pt = 0.0;
+    testVector.m_pr = -72.9380;
+    m_testVectors.Add(testVector);
+
+    testVector.m_positionA = Vector(0, 0, 25.0); // O2I case
+    testVector.m_positionB = Vector(100, 0, 1.5);
+    testVector.m_frequency = 5.0e9;
+    testVector.m_propModel = ThreeGppUmaPropagationLossModel::GetTypeId();
+    testVector.m_pt = 0.0;
+    testVector.m_pr = -86.2362;
+    m_testVectors.Add(testVector);
+
+    testVector.m_positionA = Vector(0, 0, 25.0); // O2O case
+    testVector.m_positionB = Vector(1000, 0, 1.5);
+    testVector.m_frequency = 5.0e9;
+    testVector.m_propModel = ThreeGppUmaPropagationLossModel::GetTypeId();
+    testVector.m_pt = 0.0;
+    testVector.m_pr = -109.7252;
+    m_testVectors.Add(testVector);
+
+    // tests for the UMi scenario
+    testVector.m_positionA = Vector(0, 0, 10.0); // O2I case
+    testVector.m_positionB = Vector(10, 0, 1.5);
+    testVector.m_frequency = 5.0e9;
+    testVector.m_propModel = ThreeGppUmiStreetCanyonPropagationLossModel::GetTypeId();
+    testVector.m_pt = 0.0;
+    testVector.m_pr = -69.8591;
+    m_testVectors.Add(testVector);
+
+    testVector.m_positionA = Vector(0, 0, 10.0); // O2I case
+    testVector.m_positionB = Vector(100, 0, 1.5);
+    testVector.m_frequency = 5.0e9;
+    testVector.m_propModel = ThreeGppUmiStreetCanyonPropagationLossModel::GetTypeId();
+    testVector.m_pt = 0.0;
+    testVector.m_pr = -88.4122;
+    m_testVectors.Add(testVector);
+
+    testVector.m_positionA = Vector(0, 0, 10.0); // O2O case
+    testVector.m_positionB = Vector(1000, 0, 1.5);
+    testVector.m_frequency = 5.0e9;
+    testVector.m_propModel = ThreeGppUmiStreetCanyonPropagationLossModel::GetTypeId();
+    testVector.m_pt = 0.0;
+    testVector.m_pr = -119.3114;
+    m_testVectors.Add(testVector);
+
+    // create the factory for the propagation loss model
+    ObjectFactory propModelFactory;
+
+    Ptr<Building> building = Create<Building>();
+    building->SetExtWallsType(Building::ExtWallsType_t::ConcreteWithWindows);
+    building->SetNRoomsX(1);
+    building->SetNRoomsY(1);
+    building->SetNFloors(2);
+    building->SetBoundaries(Box(0.0, 100.0, 0.0, 10.0, 0.0, 5.0));
+
+    // create the two nodes
+    NodeContainer nodes;
+    nodes.Create(2);
+
+    // create the mobility models
+    Ptr<MobilityModel> a = CreateObject<ConstantPositionMobilityModel>();
+    Ptr<MobilityModel> b = CreateObject<ConstantPositionMobilityModel>();
+
+    // aggregate the nodes and the mobility models
+    nodes.Get(0)->AggregateObject(a);
+    nodes.Get(1)->AggregateObject(b);
+
+    Ptr<MobilityBuildingInfo> buildingInfoA = CreateObject<MobilityBuildingInfo>();
+    Ptr<MobilityBuildingInfo> buildingInfoB = CreateObject<MobilityBuildingInfo>();
+    a->AggregateObject(buildingInfoA); // operation usually done by BuildingsHelper::Install
+    buildingInfoA->MakeConsistent(a);
+
+    b->AggregateObject(buildingInfoB); // operation usually done by BuildingsHelper::Install
+    buildingInfoB->MakeConsistent(b);
+
+    Ptr<ChannelConditionModel> condModel = CreateObject<BuildingsChannelConditionModel>();
+
+    for (std::size_t i = 0; i < m_testVectors.GetN(); i++)
+    {
+        TestVector testVector = m_testVectors.Get(i);
+        a->SetPosition(testVector.m_positionA);
+        b->SetPosition(testVector.m_positionB);
+
+        Ptr<ChannelCondition> cond = condModel->GetChannelCondition(a, b);
+
+        propModelFactory.SetTypeId(testVector.m_propModel);
+        m_propModel = propModelFactory.Create<ThreeGppPropagationLossModel>();
+        m_propModel->SetAttribute("Frequency", DoubleValue(testVector.m_frequency));
+        m_propModel->SetAttribute("ShadowingEnabled", BooleanValue(false));
+        m_propModel->SetChannelConditionModel(condModel);
+
+        bool isAIndoor = buildingInfoA->IsIndoor();
+        bool isBIndoor = buildingInfoB->IsIndoor();
+
+        if (!isAIndoor && !isBIndoor) // a and b are outdoor
+        {
+            cond->SetLosCondition(ChannelCondition::LosConditionValue::LOS);
+            cond->SetO2iCondition(ChannelCondition::O2iConditionValue::O2O);
+
+            // check rcv power to be equal to the calculated value without losses
+            NS_TEST_EXPECT_MSG_EQ_TOL(m_propModel->CalcRxPower(testVector.m_pt, a, b),
+                                      testVector.m_pr,
+                                      m_tolerance,
+                                      "rcv power is not equal expected value");
+        }
+        else
+        {
+            cond->SetLosCondition(ChannelCondition::LosConditionValue::LOS);
+            cond->SetO2iCondition(ChannelCondition::O2iConditionValue::O2I);
+            cond->SetO2iLowHighCondition(ChannelCondition::O2iLowHighConditionValue::LOW);
+
+            // check rcv power to be lower than the calculated without losses
+            NS_TEST_EXPECT_MSG_LT(m_propModel->CalcRxPower(testVector.m_pt, a, b),
+                                  testVector.m_pr,
+                                  "rcv power is not less than calculated value");
+        }
+        m_propModel = nullptr;
+    }
+    Simulator::Destroy();
+}
+
+/**
+ * \ingroup propagation-tests
+ *
+ * Test suite for the buildings penetration losses
+ */
+class BuildingsPenetrationLossesTestSuite : public TestSuite
+{
+  public:
+    BuildingsPenetrationLossesTestSuite();
+};
+
+BuildingsPenetrationLossesTestSuite::BuildingsPenetrationLossesTestSuite()
+    : TestSuite("buildings-penetration-losses", UNIT)
+{
+    AddTestCase(new BuildingsPenetrationLossesTestCase, TestCase::QUICK);
+}
+
+/// Static variable for test initialization
+static BuildingsPenetrationLossesTestSuite g_buildingsPenetrationLossesTestSuite;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/buildings/test/examples-to-run.py ns-3.39/src/buildings/test/examples-to-run.py
--- ns-3.38/src/buildings/test/examples-to-run.py	2023-03-16 20:54:23.584868400 -0700
+++ ns-3.39/src/buildings/test/examples-to-run.py	2023-07-05 14:23:47.717427000 -0700
@@ -1,6 +1,4 @@
 #! /usr/bin/env python3
-# -*- coding: utf-8 -*-
-## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 
 # A list of C++ examples to run in order to ensure that they remain
 # buildable and runnable over time.  Each tuple in the list contains
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/click/examples/nsclick-simple-lan.py ns-3.39/src/click/examples/nsclick-simple-lan.py
--- ns-3.38/src/click/examples/nsclick-simple-lan.py	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.39/src/click/examples/nsclick-simple-lan.py	2023-07-05 14:23:47.721427000 -0700
@@ -0,0 +1,79 @@
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License version 2 as
+# published by the Free Software Foundation;
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+# Authors: Lalith Suresh <suresh.lalith@gmail.com>
+# Modified by: Gabriel Ferreira <gabrielcarvfer@gmail.com>
+#
+
+import os.path
+
+from ns import ns
+
+ns.LogComponentEnable("Ipv4ClickRouting", ns.LOG_LEVEL_ALL)
+ns.LogComponentEnable("Ipv4L3ClickProtocol", ns.LOG_LEVEL_ALL)
+
+clickConfigFolder = os.path.dirname(__file__)
+
+csmaNodes = ns.NodeContainer()
+csmaNodes.Create(2)
+
+# Setup CSMA channel between the nodes
+csma = ns.CsmaHelper()
+csma.SetChannelAttribute("DataRate", ns.DataRateValue(ns.DataRate(5000000)))
+csma.SetChannelAttribute("Delay", ns.TimeValue(ns.MilliSeconds(2)))
+csmaDevices = csma.Install(csmaNodes)
+
+# Install normal internet stack on node B
+internet = ns.InternetStackHelper()
+internet.Install(csmaNodes.Get(1))
+
+# Install Click on node A
+clickinternet = ns.ClickInternetStackHelper()
+clickinternet.SetClickFile(csmaNodes.Get(0),
+                           clickConfigFolder + "/nsclick-lan-single-interface.click")
+clickinternet.SetRoutingTableElement(csmaNodes.Get(0), "rt")
+clickinternet.Install(csmaNodes.Get(0))
+
+# Configure IP addresses for the nodes
+ipv4 = ns.Ipv4AddressHelper()
+ipv4.SetBase("172.16.1.0", "255.255.255.0")
+ipv4.Assign(csmaDevices)
+
+# Configure traffic application and sockets
+LocalAddress = ns.InetSocketAddress(ns.Ipv4Address.GetAny(), 50000).ConvertTo()
+packetSinkHelper = ns.PacketSinkHelper("ns3::TcpSocketFactory", LocalAddress)
+recvapp = packetSinkHelper.Install(csmaNodes.Get(1))
+recvapp.Start(ns.Seconds(5.0))
+recvapp.Stop(ns.Seconds(10.0))
+
+onOffHelper = ns.OnOffHelper("ns3::TcpSocketFactory", ns.Address())
+onOffHelper.SetAttribute("OnTime", ns.StringValue("ns3::ConstantRandomVariable[Constant=1]"))
+onOffHelper.SetAttribute("OffTime", ns.StringValue("ns3::ConstantRandomVariable[Constant=0]"))
+
+appcont = ns.ApplicationContainer()
+
+remoteAddress = ns.InetSocketAddress(ns.Ipv4Address("172.16.1.2"), 50000).ConvertTo()
+onOffHelper.SetAttribute("Remote", ns.AddressValue(remoteAddress))
+appcont.Add(onOffHelper.Install(csmaNodes.Get(0)))
+
+appcont.Start(ns.Seconds(5.0))
+appcont.Stop(ns.Seconds(10.0))
+
+# For tracing
+csma.EnablePcap("nsclick-simple-lan", csmaDevices, False)
+
+ns.Simulator.Stop(ns.Seconds(20.0))
+ns.Simulator.Run()
+
+ns.Simulator.Destroy()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/click/helper/click-internet-stack-helper.cc ns-3.39/src/click/helper/click-internet-stack-helper.cc
--- ns-3.38/src/click/helper/click-internet-stack-helper.cc	2023-03-16 20:54:23.584868400 -0700
+++ ns-3.39/src/click/helper/click-internet-stack-helper.cc	2023-07-05 14:23:47.721427000 -0700
@@ -70,7 +70,6 @@
 void
 ClickInternetStackHelper::Initialize()
 {
-    SetTcp("ns3::TcpL4Protocol");
 }
 
 ClickInternetStackHelper::~ClickInternetStackHelper()
@@ -80,7 +79,6 @@
 ClickInternetStackHelper::ClickInternetStackHelper(const ClickInternetStackHelper& o)
 {
     m_ipv4Enabled = o.m_ipv4Enabled;
-    m_tcpFactory = o.m_tcpFactory;
 }
 
 ClickInternetStackHelper&
@@ -101,19 +99,6 @@
 }
 
 void
-ClickInternetStackHelper::SetTcp(const std::string tid)
-{
-    m_tcpFactory.SetTypeId(tid);
-}
-
-void
-ClickInternetStackHelper::SetTcp(std::string tid, std::string n0, const AttributeValue& v0)
-{
-    m_tcpFactory.SetTypeId(tid);
-    m_tcpFactory.Set(n0, v0);
-}
-
-void
 ClickInternetStackHelper::SetClickFile(NodeContainer c, std::string clickfile)
 {
     for (NodeContainer::Iterator i = c.Begin(); i != c.End(); ++i)
@@ -199,7 +184,7 @@
         CreateAndAggregateObjectFromTypeId(node, "ns3::Ipv4L3ClickProtocol");
         CreateAndAggregateObjectFromTypeId(node, "ns3::Icmpv4L4Protocol");
         CreateAndAggregateObjectFromTypeId(node, "ns3::UdpL4Protocol");
-        node->AggregateObject(m_tcpFactory.Create<Object>());
+        CreateAndAggregateObjectFromTypeId(node, "ns3::TcpL4Protocol");
         Ptr<PacketSocketFactory> factory = CreateObject<PacketSocketFactory>();
         node->AggregateObject(factory);
         // Set routing
@@ -488,7 +473,7 @@
                 "Drop",
                 MakeBoundCallback(&Ipv4L3ProtocolDropSinkWithoutContext, theStream));
             NS_ASSERT_MSG(result == true,
-                          "ClickInternetStackHelper::EanableAsciiIpv4Internal():  "
+                          "ClickInternetStackHelper::EnableAsciiIpv4Internal():  "
                           "Unable to connect ipv4L3Protocol \"Drop\"");
         }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/click/helper/click-internet-stack-helper.h ns-3.39/src/click/helper/click-internet-stack-helper.h
--- ns-3.38/src/click/helper/click-internet-stack-helper.h	2023-03-16 20:54:23.584868400 -0700
+++ ns-3.39/src/click/helper/click-internet-stack-helper.h	2023-07-05 14:23:47.721427000 -0700
@@ -102,34 +102,6 @@
     void InstallAll() const;
 
     /**
-     * \brief set the Tcp stack which will not need any other parameter.
-     *
-     * This function sets up the tcp stack to the given TypeId. It should not be
-     * used for NSC stack setup because the nsc stack needs the Library attribute
-     * to be setup, please use instead the version that requires an attribute
-     * and a value. If you choose to use this function anyways to set nsc stack
-     * the default value for the linux library will be used: "liblinux2.6.26.so".
-     *
-     * \param tid the type id, typically it is set to  "ns3::TcpL4Protocol"
-     */
-    void SetTcp(std::string tid);
-
-    /**
-     * \brief This function is used to setup the Network Simulation Cradle stack with library value.
-     *
-     * Give the NSC stack a shared library file name to use when creating the
-     * stack implementation.  The attr string is actually the attribute name to
-     * be setup and val is its value. The attribute is the stack implementation
-     * to be used and the value is the shared library name.
-     *
-     * \param tid The type id, for the case of nsc it would be "ns3::NscTcpL4Protocol"
-     * \param attr The attribute name that must be setup, for example "Library"
-     * \param val The attribute value, which will be in fact the shared library name
-     * (example:"liblinux2.6.26.so")
-     */
-    void SetTcp(std::string tid, std::string attr, const AttributeValue& val);
-
-    /**
      * \brief Set a Click file to be used for a group of nodes.
      * \param c NodeContainer of nodes
      * \param clickfile Click file to be used
@@ -200,7 +172,6 @@
                                  bool explicitFilename) override;
 
     void Initialize();
-    ObjectFactory m_tcpFactory;
 
     static void CreateAndAggregateObjectFromTypeId(Ptr<Node> node, const std::string typeId);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/click/model/ipv4-click-routing.cc ns-3.39/src/click/model/ipv4-click-routing.cc
--- ns-3.38/src/click/model/ipv4-click-routing.cc	2023-03-16 20:54:23.584868400 -0700
+++ ns-3.39/src/click/model/ipv4-click-routing.cc	2023-07-05 14:23:47.721427000 -0700
@@ -227,14 +227,7 @@
 bool
 Ipv4ClickRouting::IsInterfaceReady(int ifid)
 {
-    if (ifid >= 0 && ifid < (int)m_ipv4->GetNInterfaces())
-    {
-        return true;
-    }
-    else
-    {
-        return false;
-    }
+    return ifid >= 0 && ifid < static_cast<int>(m_ipv4->GetNInterfaces());
 }
 
 std::string
@@ -285,19 +278,21 @@
     struct timeval curtime;
     uint64_t remainder = 0;
 
-    curtime.tv_sec = Simulator::Now().GetSeconds();
-    curtime.tv_usec = Simulator::Now().GetMicroSeconds() % 1000000;
+    Time now = Simulator::Now();
+
+    curtime.tv_sec = now.GetSeconds();
+    curtime.tv_usec = now.GetMicroSeconds() % 1000000;
 
-    switch (Simulator::Now().GetResolution())
+    switch (Time::GetResolution())
     {
     case Time::NS:
-        remainder = Simulator::Now().GetNanoSeconds() % 1000;
+        remainder = now.GetNanoSeconds() % 1000;
         break;
     case Time::PS:
-        remainder = Simulator::Now().GetPicoSeconds() % 1000000;
+        remainder = now.GetPicoSeconds() % 1000000;
         break;
     case Time::FS:
-        remainder = Simulator::Now().GetFemtoSeconds() % 1000000000;
+        remainder = now.GetFemtoSeconds() % 1000000000;
         break;
     default:
         break;
@@ -563,10 +558,10 @@
 Ipv4ClickRouting::RouteInput(Ptr<const Packet> p,
                              const Ipv4Header& header,
                              Ptr<const NetDevice> idev,
-                             UnicastForwardCallback ucb,
-                             MulticastForwardCallback mcb,
-                             LocalDeliverCallback lcb,
-                             ErrorCallback ecb)
+                             const UnicastForwardCallback& ucb,
+                             const MulticastForwardCallback& mcb,
+                             const LocalDeliverCallback& lcb,
+                             const ErrorCallback& ecb)
 {
     NS_FATAL_ERROR("Click router does not have a RouteInput() interface!");
     return false;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/click/model/ipv4-click-routing.h ns-3.39/src/click/model/ipv4-click-routing.h
--- ns-3.38/src/click/model/ipv4-click-routing.h	2023-03-16 20:54:23.584868400 -0700
+++ ns-3.39/src/click/model/ipv4-click-routing.h	2023-07-05 14:23:47.721427000 -0700
@@ -262,10 +262,10 @@
     bool RouteInput(Ptr<const Packet> p,
                     const Ipv4Header& header,
                     Ptr<const NetDevice> idev,
-                    UnicastForwardCallback ucb,
-                    MulticastForwardCallback mcb,
-                    LocalDeliverCallback lcb,
-                    ErrorCallback ecb) override;
+                    const UnicastForwardCallback& ucb,
+                    const MulticastForwardCallback& mcb,
+                    const LocalDeliverCallback& lcb,
+                    const ErrorCallback& ecb) override;
     void PrintRoutingTable(Ptr<OutputStreamWrapper> stream,
                            Time::Unit unit = Time::S) const override;
     void NotifyInterfaceUp(uint32_t interface) override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/click/model/ipv4-l3-click-protocol.cc ns-3.39/src/click/model/ipv4-l3-click-protocol.cc
--- ns-3.38/src/click/model/ipv4-l3-click-protocol.cc	2023-03-16 20:54:23.584868400 -0700
+++ ns-3.39/src/click/model/ipv4-l3-click-protocol.cc	2023-07-05 14:23:47.721427000 -0700
@@ -229,11 +229,10 @@
 #ifdef NOTYET
         if (MulticastCheckGroup(iif, address))
 #endif
-            if (true)
-            {
-                NS_LOG_LOGIC("For me (Ipv4Addr multicast address");
-                return true;
-            }
+        {
+            NS_LOG_LOGIC("For me (Ipv4Addr multicast address");
+            return true;
+        }
     }
 
     if (address.IsBroadcast())
@@ -470,7 +469,7 @@
         Ipv4InterfaceAddress test = GetAddress(interfaceIdx, i);
         if (test.GetLocal().CombineMask(test.GetMask()) == dest.CombineMask(test.GetMask()))
         {
-            if (test.IsSecondary() == false)
+            if (!test.IsSecondary())
             {
                 return test.GetLocal();
             }
@@ -677,7 +676,7 @@
     ipHeader.SetProtocol(protocol);
     ipHeader.SetPayloadSize(payloadSize);
     ipHeader.SetTtl(ttl);
-    if (mayFragment == true)
+    if (mayFragment)
     {
         ipHeader.SetMayFragment();
         ipHeader.SetIdentification(m_identification);
@@ -786,7 +785,7 @@
     NS_LOG_LOGIC("Packet from " << from << " received on node " << m_node->GetId());
 
     // Forward packet to raw sockets, if any
-    if (protocol == Ipv4L3ClickProtocol::PROT_NUMBER && m_sockets.size() > 0)
+    if (protocol == Ipv4L3ClickProtocol::PROT_NUMBER && !m_sockets.empty())
     {
         Ptr<Packet> packetForRawSocket = p->Copy();
         int32_t interface = GetInterfaceForDevice(device);
@@ -844,7 +843,7 @@
         // we need to make a copy in the unlikely event we hit the
         // RX_ENDPOINT_UNREACH codepath
         Ptr<Packet> copy = p->Copy();
-        enum IpL4Protocol::RxStatus status = protocol->Receive(p, ip, GetInterface(iif));
+        IpL4Protocol::RxStatus status = protocol->Receive(p, ip, GetInterface(iif));
         switch (status)
         {
         case IpL4Protocol::RX_OK:
@@ -854,8 +853,7 @@
         case IpL4Protocol::RX_CSUM_FAILED:
             break;
         case IpL4Protocol::RX_ENDPOINT_UNREACH:
-            if (ip.GetDestination().IsBroadcast() == true ||
-                ip.GetDestination().IsMulticast() == true)
+            if (ip.GetDestination().IsBroadcast() || ip.GetDestination().IsMulticast())
             {
                 break; // Do not reply to broadcast or multicast
             }
@@ -871,7 +869,7 @@
                     subnetDirected = true;
                 }
             }
-            if (subnetDirected == false)
+            if (!subnetDirected)
             {
                 GetIcmp()->SendDestUnreachPort(ip, copy);
             }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/click/test/examples-to-run.py ns-3.39/src/click/test/examples-to-run.py
--- ns-3.38/src/click/test/examples-to-run.py	2023-03-16 20:54:23.584868400 -0700
+++ ns-3.39/src/click/test/examples-to-run.py	2023-07-05 14:23:47.737427000 -0700
@@ -1,5 +1,4 @@
 #! /usr/bin/env python3
-## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 
 # A list of C++ examples to run in order to ensure that they remain
 # buildable and runnable over time.  Each tuple in the list contains
@@ -22,4 +21,6 @@
 #     (example_name, do_run).
 #
 # See test.py for more information.
-python_examples = []
+python_examples = [
+    ("nsclick-simple-lan.py", "NSCLICK == True"),
+]
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/config-store/CMakeLists.txt ns-3.39/src/config-store/CMakeLists.txt
--- ns-3.38/src/config-store/CMakeLists.txt	2023-03-16 20:54:23.584868400 -0700
+++ ns-3.39/src/config-store/CMakeLists.txt	2023-07-05 14:23:47.737427000 -0700
@@ -12,6 +12,13 @@
   set(gtk_libraries
       ${GTK3_LIBRARIES}
   )
+  if(${NS3_PIP_PACKAGING})
+    # In case we are packaging ns-3, leave gtk symbols undefined and pray for
+    # the linker to find the correct libraries locally
+    set(gtk_libraries
+        -Wl,--allow-shlib-undefined
+    )
+  endif()
   if(${GCC})
     add_definitions(-Wno-parentheses)
   endif()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/config-store/model/attribute-default-iterator.cc ns-3.39/src/config-store/model/attribute-default-iterator.cc
--- ns-3.38/src/config-store/model/attribute-default-iterator.cc	2023-03-16 20:54:23.584868400 -0700
+++ ns-3.39/src/config-store/model/attribute-default-iterator.cc	2023-07-05 14:23:47.741427200 -0700
@@ -45,7 +45,7 @@
         bool calledStart = false;
         for (uint32_t j = 0; j < tid.GetAttributeN(); j++)
         {
-            struct TypeId::AttributeInformation info = tid.GetAttribute(j);
+            TypeId::AttributeInformation info = tid.GetAttribute(j);
             if (!(info.flags & TypeId::ATTR_CONSTRUCT))
             {
                 // we can't construct the attribute, so, there is no
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/config-store/model/attribute-iterator.cc ns-3.39/src/config-store/model/attribute-iterator.cc
--- ns-3.38/src/config-store/model/attribute-iterator.cc	2023-03-16 20:54:23.584868400 -0700
+++ ns-3.39/src/config-store/model/attribute-iterator.cc	2023-07-05 14:23:47.741427200 -0700
@@ -226,7 +226,7 @@
         NS_LOG_DEBUG("store " << tid.GetName());
         for (uint32_t i = 0; i < tid.GetAttributeN(); ++i)
         {
-            struct TypeId::AttributeInformation info = tid.GetAttribute(i);
+            TypeId::AttributeInformation info = tid.GetAttribute(i);
             const PointerChecker* ptrChecker =
                 dynamic_cast<const PointerChecker*>(PeekPointer(info.checker));
             if (ptrChecker != nullptr)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/config-store/model/display-functions.cc ns-3.39/src/config-store/model/display-functions.cc
--- ns-3.38/src/config-store/model/display-functions.cc	2023-03-16 20:54:23.584868400 -0700
+++ ns-3.39/src/config-store/model/display-functions.cc	2023-07-05 14:23:47.741427200 -0700
@@ -240,7 +240,7 @@
         }
         else
         {
-            struct TypeId::AttributeInformation info = tid.GetAttribute(attrIndex);
+            TypeId::AttributeInformation info = tid.GetAttribute(attrIndex);
             Ptr<const AttributeChecker> checker = info.checker;
             std::string tip;
             tip = "This attribute is of type " + checker->GetValueTypeName();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/config-store/model/raw-text-config.cc ns-3.39/src/config-store/model/raw-text-config.cc
--- ns-3.38/src/config-store/model/raw-text-config.cc	2023-03-16 20:54:23.584868400 -0700
+++ ns-3.39/src/config-store/model/raw-text-config.cc	2023-07-05 14:23:47.741427200 -0700
@@ -93,7 +93,7 @@
             ns3::TypeId::SupportLevel supportLevel = TypeId::SupportLevel::SUPPORTED;
             for (std::size_t i = 0; i < tid.GetAttributeN(); i++)
             {
-                struct TypeId::AttributeInformation tmp = tid.GetAttribute(i);
+                TypeId::AttributeInformation tmp = tid.GetAttribute(i);
                 if (tmp.name == name)
                 {
                     supportLevel = tmp.supportLevel;
@@ -105,8 +105,7 @@
                 NS_LOG_WARN("Global attribute " << m_typeId << "::" << name
                                                 << " was not saved because it is OBSOLETE");
             }
-            else if ((supportLevel == TypeId::SupportLevel::DEPRECATED) &&
-                     (m_saveDeprecated == false))
+            else if (supportLevel == TypeId::SupportLevel::DEPRECATED && !m_saveDeprecated)
             {
                 NS_LOG_WARN("Global attribute " << m_typeId << "::" << name
                                                 << " was not saved because it is DEPRECATED");
@@ -169,7 +168,7 @@
 
             for (std::size_t i = 0; i < tid.GetAttributeN(); i++)
             {
-                struct TypeId::AttributeInformation tmp = tid.GetAttribute(i);
+                TypeId::AttributeInformation tmp = tid.GetAttribute(i);
                 if (tmp.name == name)
                 {
                     supportLevel = tmp.supportLevel;
@@ -181,8 +180,7 @@
                 NS_LOG_WARN("Attribute " << GetCurrentPath()
                                          << " was not saved because it is OBSOLETE");
             }
-            else if ((supportLevel == TypeId::SupportLevel::DEPRECATED) &&
-                     (m_saveDeprecated == false))
+            else if (supportLevel == TypeId::SupportLevel::DEPRECATED && !m_saveDeprecated)
             {
                 NS_LOG_WARN("Attribute " << GetCurrentPath()
                                          << " was not saved because it is DEPRECATED");
